<?php

/**
 * hist_cerrar_proyeccion actions.
 *
 * @package    canon
 * @subpackage hist_cerrar_proyeccion
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class hist_cerrar_proyeccionActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        /*
         * Manejo de errores
         */
        try {

            //Parametros generales
            $fechaActual = CN_TABLE::fechaSistema();

            //Parametros generales
            $id_titulo = $request['id_titulo'];
            //$idTituloEtapas = $request['id_titulo_etapas'];
            $codTitulo = $request['cod_titulo'];

            //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
            $id_ope_bd = 2;
            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_titulo_etapa');
            //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
            $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, "Se creo una proyección nueva para el título " . $codTitulo);

            //Validaciones:
            //1. El titulo debe tener por lo menos una etapa ER o ER y CYM
            //2. La primera etapa debe tener mínimo una anualidad.--Comentada la validacion
            //3. Validar que la fecha inicio de la etapa sea la misma fecha inicio de la primera anualidad de esa etapa.
            //4. Validar que la fecha fin de la etapa sea la misma que la fecha fin de la ultima anualidad de esa etapa.
            //5. Validar que el numero de anualidades de una etapa correspondan al verdadero numero de anualidades.


            $sql = <<<EOD

select te.* from ca_titulo_etapa_hist eh join ca_titulo_etapa te on eh.id_titulo_etapa=te.id_titulo_etapa where eh.id_titulo=$id_titulo and eh.en_proceso=1  order by id_etapa

EOD;

            $recordsTituloEtapa = CN_TABLE::executeSQL($sql, true);

            if (count($recordsTituloEtapa) > 0) {


                if (count($recordsTituloEtapa) == 2) {

                    if ($recordsTituloEtapa[0]['id_etapa'] != 1 || $recordsTituloEtapa[1]['id_etapa'] != 2) {
                        throw new Exception("La proyección debe tener una etapa de ER y una de CYM");
                    }
                }else if(count($recordsTituloEtapa) == 1) {
                    if ($recordsTituloEtapa[0]['id_etapa'] != 1) {
                        throw new Exception("La proyección debe tener una etapa de ER");
                    }
                }


                foreach ($recordsTituloEtapa as $value) {

                    $IdTit = $value['id_titulo_etapa'];
                    $etapa = $value['id_etapa'];
                    $anualidades = $value['anualidades'];
                    if ($etapa == 1 && $anualidades == 0 && count($recordsTituloEtapa)==2) {
                        //verificar numero de anualidades de la segunda etapa, si son diferentes de cero apuntar esta etapa como inicio de liquidacion
                        if($recordsTituloEtapa[1]['anualidades'] != 0)
                        {
                            $idTit2=$recordsTituloEtapa[1]['id_titulo_etapa'];
                            
                                    $sql = <<<EOD

update ca_titulo_etapa
set estado            =1
WHERE ID_TITULO_ETAPA = $idTit2
AND ID_TITULO         = $id_titulo

EOD;
                    CN_TABLE::executeSQL($sql, true);
                        }
                        

                    } else {
                        //Para la etapa 2
                    }

                            $sql = <<<EOD

select count(*) as anu from ca_anual_etapa where id_titulo=$id_titulo and id_titulo_etapa=$IdTit

EOD;
                    $records = CN_TABLE::executeSQL($sql, true);
                    
                    $anu=$records[0]['anu'];
                    
                    
                    //Para todas las etapas
                    //3. Validar que la fecha inicio de la etapa sea la misma fecha inicio de la primera anualidad de esa etapa.

                    $sql = <<<EOD

select count(*) as count from ca_anual_etapa ae join ca_titulo_etapa te on ae.id_titulo_etapa=te.id_titulo_etapa where ae.id_titulo=$id_titulo and ae.id_titulo_etapa=$IdTit and rownum=1 and ae.fecha_inicio =te.fecha_inicio
order by ae.anualidad asc

EOD;
                    $records = CN_TABLE::executeSQL($sql, true);

                    if ($records[0]['count'] == 0 && $anu!=0) {
                        throw new Exception("La fecha inicio de la etapa debe ser la misma fecha inicio de la primera anualidad de esa etapa");
                    }

                    //4. Validar que la fecha fin de la etapa sea la misma que la fecha fin de la ultima anualidad de esa etapa.

                    $sql = <<<EOD

select count(*) as count from ca_anual_etapa ae join ca_titulo_etapa te on ae.id_titulo_etapa=te.id_titulo_etapa where ae.id_titulo=$id_titulo and ae.id_titulo_etapa=$IdTit and rownum=1 and ae.fecha_inicio =te.fecha_inicio
order by ae.anualidad asc

EOD;
                    $records = CN_TABLE::executeSQL($sql, true);

                    if ($records[0]['count'] == 0 && $anu!=0) {
                        throw new Exception("La fecha fin de la etapa debe ser la misma que la fecha fin de la ultima anualidad de esa etapa");
                    }

                    //5. Validar que el numero de anualidades de una etapa correspondan al numero de anualidades declaradas en el titulo etapa

                    $sql = <<<EOD


select count(*) as count from ca_anual_etapa where id_titulo_etapa=$IdTit

EOD;
                    $records = CN_TABLE::executeSQL($sql, true);

                    if ($records[0]['count'] != $anualidades) {
                        throw new Exception("La etapa fue definida con " . $anualidades . " anualidad(es) y solo se ha creado " . $records[0]['count'] . " anualidad(es)");
                    }

                    //Update para cada titulo etapa, para establecerla en la proyección actual.
                    $sql = <<<EOD

update ca_titulo_etapa
set actual            =1
WHERE ID_TITULO_ETAPA = $IdTit
AND ID_TITULO         = $id_titulo

EOD;
                    CN_TABLE::executeSQL($sql, true);

                    //En proceso en ca_titulo_etapa_hist es false

                    $sql = <<<EOD

UPDATE CA_TITULO_ETAPA_HIST
SET EN_PROCESO      =0
WHERE ID_TITULO     = $id_titulo
AND ID_TITULO_ETAPA = $IdTit
    
EOD;
                    CN_TABLE::executeSQL($sql, true);
                }
            } else {

                throw new Exception("La proyección de un título debe tener por lo menos una etapa");
            }


            $this->conn->commit();

            $this->totalRows = 1;
            $this->startRow = 0;
            $this->endRow = 1;
            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[HIST_CERRAR_PROYECCION] Consulta exitosa.");
        } catch (Exception $e) {

            $this->conn->rollback();
            $error = "[HIST_CERRAR_PROYECCION] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}

